# -*- coding: UTF-8 -*-

"""
дто-объекты для конвертера ukm-xml
TODO: когда откажемся от python2 переделать на dataclass!!!
"""


class UkmTmc(object):
    """
    тег в xml -  UpdateItems -> item
    """

    def __init__(self, article, barcode, name, measure, measprec, taxgroupId=None,
                 ProductAlcCodes=None, egaisType=0, SubExcise=0, TNVDcode=None, groupId=None, propertyId=None,
                 crptNotUnique=None, addProperty=None):
        self.article = article
        self.barcode = barcode
        self.name = name
        self.measure = measure
        self.measprec = measprec
        self.groupId = groupId
        self.egaisType = egaisType
        self.SubExcise = SubExcise
        self.TNVDcode = TNVDcode
        self.taxgroupId = taxgroupId
        self.ProductAlcCodes = ProductAlcCodes
        # с этими полями мы не знаем, что делать, они тут для целостности объекта
        self.propertyId = propertyId
        self.crptNotUnique = crptNotUnique
        self.addProperty = addProperty


class UkmBarcode(object):

    """
    тег в xml -  barcode, вложенная сущность
    родительский тег - UpdateItems -> item
    """

    def __init__(self, id, quantity, article=None, name=None):
        self.id = id
        self.quantity = quantity
        self.article = article
        self.name = name


class ProductAlcCode(object):
    """
    тег в xml -  ProductAlcCodes -> AlcCode, вложенная сущность
    родительский тег - UpdateItems -> item
    """

    def __init__(self, AlcCode, article=None):
        self.AlcCode = AlcCode
        self.article = article


class UkmGroup(object):

    """
    тег в xml -  classif -> group
    """

    def __init__(self, id, name, owner):
        self.id = id
        self.name = name
        self.owner = owner


class UkmPrice(object):

    """
    root тег в xml -  storePrices -> item
    имеет атрибут - storeId, судя по всему, справочник загружается на магазин
    в нашей вселенной это переоценки (prices)
    загружаем если storeId совпадает с текущим кодом магазина на узле
    """

    def __init__(self, article, value, minprice=None, mrc=None):
        self.article = article
        self.value = value
        self.minprice = minprice
        self.mrc = mrc


class UkmTprice(object):
    """
    root тег в xml -  storePricesAdd -> item
    имеет атрибут - storeId, судя по всему, справочник загружается на магазин
    в нашей вселенной это доп.цены (tprices) - выбор пал на эту таблицу, т.к. судя по всему, справочник содержит цены для дисконта
    загружаем если storeId совпадает с текущим кодом магазина на узле
    """

    def __init__(self, code, name, article, value):
        self.code = code
        self.name = name
        self.article = article
        self.value = value


class UkmTaxGroup(object):

    """
    тег в xml -  taxes -> group
    """

    def __init__(self, id, code, tax):
        self.id = id
        self.code = code
        self.tax = tax


class UkmTax(object):
    """
    тег в xml -  taxes -> tax
    """

    def __init__(self, id, name, sequence, percent):
        self.id = id
        self.name = name
        self.sequence = sequence
        self.percent = percent


class UkmKit(object):
    """
    тег в xml -  kit -> item
    """

    def __init__(self, article, subItem):
        self.article = article
        self.subItem = subItem


class UkmKitItem(object):
    """
    тег в xml -  kit -> item -> subItem
    """

    def __init__(self, article, quantity, parentcode):
        self.article = article
        self.quantity = quantity
        self.parentcode = parentcode
